Unit zp16e_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTZP11_p;

procedure zp16e(var A :Array of Extended; var NREAL :Integer;
                var ROOT :Array of Extended; var IERR :Integer);

implementation

procedure zp16e(var A :Array of Extended; var NREAL :Integer;
                var ROOT :Array of Extended; var IERR :Integer);
var
P,R1,R2,X,Y,Z :Extended;
const
SYS007 :Real = 1.0471975511965977461542144610932;
label
_10,_20,_30,_40,_15,_16,_60;
begin
IERR  := 0;
R1  := 3.e0*A[0];
if ( A[0] <>  0.e0 ) 
 then goto _10;
IERR  := 65;
UTZP11(IERR,16);
goto _60;
_10:
R2  := A[1]/R1;
X  := A[2]/R1 - IntPower(R2,2);
Y  := 3.e0*A[3]/R1 + 2.e0*IntPower(R2,3) - 3.e0*R2*(A[2]/R1);
Z  := -2.e0*Sqrt(Abs(X));
if ( X  <>  0.e0  ) or (  Y  <>  0.e0 ) 
 then goto _20;
NREAL  := 3;
ROOT[0] := -R2;
ROOT[1] := ROOT[0];
ROOT[2] := ROOT[0];
goto _60;
_20:
if ( Abs(Y)-X*Z ) < 0
 then goto _30
 else if ( Abs(Y)-X*Z ) > 0
       then goto _40
       else goto _15;
_30:
NREAL  := 3;
Y  := (Y/X)/Z;
Y  := (2.e0/3.e0)*ArcTan2(Sqrt(1.e0-Y),Sqrt(1.e0+Y));
P  := Z*Cos(Y) - R2;
X  := -Z*Cos(Y-SYS007) - R2;
Y  := -Z*Cos(Y+SYS007) - R2;
ROOT[0] := EMin1(EMin1(P,X),Y);
ROOT[2] := EMax1(EMax1(P,X),Y);
ROOT[1] := -A[1]/A[0] - ROOT[0] - ROOT[2];
goto _60;
_40:
Z := X*Z;
R1 := EMax1(Abs(Y),Abs(Z));
Z := R1*Sqrt(IntPower(Y/R1,2)-(Z/R1)*(Abs(Z)/R1));
Z  := 0.5e0*(Z + (Y/Z)*Y + (4.e0*X/Z)*X*X);
goto _16;
_15:
Z := 0;
_16:
NREAL  := 1;
P  := Y + Z;
X  := Sign(Power((Sqrt(0.5e0)*Sqrt(Abs(P))),2.e0/3.e0),P);
P  := Y - Z;
Y  := Sign(Power((Sqrt(0.5e0)*Sqrt(Abs(P))),2.e0/3.e0),P);
Z  := X + Y;
ROOT[0] := -Z - R2;
ROOT[1] := 0.5e0*Z - R2;
ROOT[2] := Sqrt(0.75e0)*Abs(X-Y);
_60:
end;

end.
